﻿using System;
using System.Collections.ObjectModel;
using System.Linq;
using System.Windows.Controls;
using Telerik.Windows.Controls;

namespace RadMenu
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();

            rootMenu.ItemsSource = GetMenuItems();
        }

        private void rootMenu_ItemClick(object sender, Telerik.Windows.RadRoutedEventArgs e)
        {
            var radMenuItem = e.OriginalSource as RadMenuItem;
            if (radMenuItem != null)
            {
                txtMenuItem.Text = (radMenuItem.DataContext as MenuItem).ApplicationName;
            }

            
        }

        public class MenuItem
        {
            public MenuItem()
            {
                this.ChildItems = new ObservableCollection<MenuItem>();
            }

            public Guid Id { get; set; }
            public string ApplicationName { get; set; }
            public int ChildID { get; set; }
            public int ParentID { get; set; }
            public string ImageUrl { get; set; }
            public ObservableCollection<MenuItem> ChildItems
            {
                get;
                set;
            }
        }

        private ObservableCollection<MenuItem> GetMenuItems()
        {
            ObservableCollection<MenuItem> parents = new ObservableCollection<MenuItem>();

            var model1 = new MenuItem();

            model1.Id = Guid.NewGuid();
            model1.ApplicationName = "Model1";
            model1.ChildID = 0;
            model1.ParentID = 0;
            model1.ImageUrl = "Images/safeWhite.png";

            ObservableCollection<MenuItem> childs1 = new ObservableCollection<MenuItem>();
            var model2 = new MenuItem();

            model2.Id = Guid.NewGuid();
            model2.ApplicationName = "Model2";
            model2.ChildID = 1;
            model2.ParentID = 0;
            model2.ImageUrl = "Images/notebookWhite.png";

            var model3 = new MenuItem();

            model3.Id = Guid.NewGuid();
            model3.ApplicationName = "Model3";
            model3.ChildID = 2;
            model3.ParentID = 0;
            model3.ImageUrl = "Images/user-guestWhite.png";

            ObservableCollection<MenuItem> grandChilds1 = new ObservableCollection<MenuItem>();
            var childModel1 = new MenuItem();

            childModel1.Id = Guid.NewGuid();
            childModel1.ApplicationName = "childModel1";
            childModel1.ChildID = 0;
            childModel1.ParentID = 1;

            var childModel2 = new MenuItem();

            childModel2.Id = Guid.NewGuid();
            childModel2.ApplicationName = "childModel2";
            childModel2.ChildID = 1;
            childModel2.ParentID = 1;


            var secondChildModel1 = new MenuItem();

            secondChildModel1.Id = Guid.NewGuid();
            secondChildModel1.ApplicationName = "secondChildModel1";
            secondChildModel1.ChildID = 0;
            secondChildModel1.ParentID = 1;

            var secondChildModel2 = new MenuItem();

            secondChildModel2.Id = Guid.NewGuid();
            secondChildModel2.ApplicationName = "secondChildModel2";
            secondChildModel2.ChildID = 1;
            secondChildModel2.ParentID = 1;

            grandChilds1.Add(secondChildModel1);
            grandChilds1.Add(secondChildModel2);

            childModel1.ChildItems = grandChilds1;
            childs1.Add(childModel1);
            childs1.Add(childModel2);

            model2.ChildItems = childs1;
            parents.Add(model1);
            parents.Add(model2);
            parents.Add(model3);

            return parents;
        }

       
    }
}
